/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VMissinglistUsersRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VMissinglistUsers extends TableImpl<VMissinglistUsersRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_missinglist_users</code>
     */
    public static final VMissinglistUsers V_MISSINGLIST_USERS = new VMissinglistUsers();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VMissinglistUsersRecord> getRecordType() {
        return VMissinglistUsersRecord.class;
    }

    /**
     * The column <code>common_dd.v_missinglist_users.fk_missinglist</code>.
     */
    public final TableField<VMissinglistUsersRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_missinglist_users.variables</code>.
     */
    public final TableField<VMissinglistUsersRecord, String[]> VARIABLES = createField(DSL.name("variables"), SQLDataType.CLOB.array(), this, "");

    private VMissinglistUsers(Name alias, Table<VMissinglistUsersRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VMissinglistUsers(Name alias, Table<VMissinglistUsersRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_missinglist_users" as  SELECT v.fk_missinglist,
          array_agg(h.unique_name) AS variables
         FROM (common_dd.t_core_variable v
           LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
        WHERE (v.fk_missinglist IS NOT NULL)
        GROUP BY v.fk_missinglist;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_missinglist_users</code> table
     * reference
     */
    public VMissinglistUsers(String alias) {
        this(DSL.name(alias), V_MISSINGLIST_USERS);
    }

    /**
     * Create an aliased <code>common_dd.v_missinglist_users</code> table
     * reference
     */
    public VMissinglistUsers(Name alias) {
        this(alias, V_MISSINGLIST_USERS);
    }

    /**
     * Create a <code>common_dd.v_missinglist_users</code> table reference
     */
    public VMissinglistUsers() {
        this(DSL.name("v_missinglist_users"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VMissinglistUsers as(String alias) {
        return new VMissinglistUsers(DSL.name(alias), this);
    }

    @Override
    public VMissinglistUsers as(Name alias) {
        return new VMissinglistUsers(alias, this);
    }

    @Override
    public VMissinglistUsers as(Table<?> alias) {
        return new VMissinglistUsers(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VMissinglistUsers rename(String name) {
        return new VMissinglistUsers(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMissinglistUsers rename(Name name) {
        return new VMissinglistUsers(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMissinglistUsers rename(Table<?> name) {
        return new VMissinglistUsers(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers where(Condition condition) {
        return new VMissinglistUsers(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMissinglistUsers where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMissinglistUsers where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMissinglistUsers where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMissinglistUsers where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMissinglistUsers whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
